﻿using System;
using Microsoft.Xna.Framework;
using CellarDoor.Gui.Elements;
using CellarDoor.Gui.Controller;
using CellarDoor.Gui.Animation;
using CellarDoor.Gui.Theming;
using CellarDoor.Gui.Layout;

namespace CellarDoor.Gui.Layout
{
    public class UiVisualStyleChecked : UiVisualStyleWithState
    {
        public UiVisualLayer CheckedLayer { get; protected set; }

        public UiVisualStyleChecked(UiElement element)
            : base(element)
        {
            CheckedLayer = new UiVisualLayer();
            CheckedLayer.Enabled = false;
        }

        protected override void LoadTheme(UiTheme theme, int resX, int resY)
        {
            if (ElementName != null)
            {
                this.CheckedLayer.Sprite = theme.GetState(ElementName, "Checked", resX, resY);
            }

            base.LoadTheme(theme, resX, resY);
        }

        public override void SetTargetArea(Rectangle area)
        {
            CheckedLayer.SetTargetArea(area);

            base.SetTargetArea(area);
        }

        public override void Draw(UiManager manager, Color color)
        {
            Draw(manager, ShadowLayer, color);
            Draw(manager, StateLayer, color);
            Draw(manager, CheckedLayer, color);
            Draw(manager, Overlay, color);
        }
    }
}
