﻿using System;
using Microsoft.Xna.Framework;
using CellarDoor.Gui.Elements;
using CellarDoor.Gui.Controller;
using CellarDoor.Gui.Animation;
using CellarDoor.Gui.Theming;
using CellarDoor.Gui.Layout;

namespace CellarDoor.Gui.Layout
{
    public class UiVisualStyleProgress : UiVisualStyleWithState
    {
        public UiVisualLayer EmptyLayer { get; protected set; }
        public UiVisualLayer FullLayer { get; protected set; }
        public float Progress { get; set; }

        public UiVisualStyleProgress(UiElement element)
            : base(element)
        {
            EmptyLayer = new UiVisualLayer();
            FullLayer = new UiVisualLayer();
        }

        protected override void LoadTheme(UiTheme theme, int resX, int resY)
        {
            if (ElementName != null)
            {
                this.EmptyLayer.Sprite = theme.GetState(ElementName, "Empty", resX, resY);
                this.FullLayer.Sprite = theme.GetState(ElementName, "Full", resX, resY);
            }

            base.LoadTheme(theme, resX, resY);
        }

        public override void SetTargetArea(Rectangle area)
        {
            EmptyLayer.SetTargetArea(area);
            area.Width = (int)(Progress * area.Width);
            FullLayer.SetTargetArea(area);

            base.SetTargetArea(area);
        }

        public override void Draw(UiManager manager, Color color)
        {
            Draw(manager, ShadowLayer, color);
            Draw(manager, EmptyLayer, color);
            Draw(manager, FullLayer, color);
            Draw(manager, Overlay, color);
        }
    }
}
